diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-snoopy.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-snoopy.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-snoopy.php	2010-10-27 04:54:17.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-snoopy.php	2013-07-08 12:17:46.000000000 -0500
***************
*** 910,916 ****
  			return false;
  		}
  
! 		// check if there is a a redirect meta tag
  
  		if(preg_match("'<meta[\s]*http-equiv[^>]*?content[\s]*=[\s]*[\"\']?\d+;[\s]*URL[\s]*=[\s]*([^\"\']*?)[\"\']?>'i",$results,$match))
  
--- 910,916 ----
  			return false;
  		}
  
! 		// check if there is a redirect meta tag
  
  		if(preg_match("'<meta[\s]*http-equiv[^>]*?content[\s]*=[\s]*[\"\']?\d+;[\s]*URL[\s]*=[\s]*([^\"\']*?)[\"\']?>'i",$results,$match))
  
***************
*** 1010,1016 ****
  		if($this->read_timeout > 0)
  			$cmdline_params .= " -m ".$this->read_timeout;
  
! 		$headerfile = tempnam($temp_dir, "sno");
  
  		exec($this->curl_path." -k -D \"$headerfile\"".$cmdline_params." \"".escapeshellcmd($URI)."\"",$results,$return);
  
--- 1010,1016 ----
  		if($this->read_timeout > 0)
  			$cmdline_params .= " -m ".$this->read_timeout;
  
! 		$headerfile = tempnam($this->temp_dir, "sno");
  
  		exec($this->curl_path." -k -D \"$headerfile\"".$cmdline_params." \"".escapeshellcmd($URI)."\"",$results,$return);
  
***************
*** 1057,1063 ****
  			$this->headers[] = $result_headers[$currentHeader];
  		}
  
! 		// check if there is a a redirect meta tag
  
  		if(preg_match("'<meta[\s]*http-equiv[^>]*?content[\s]*=[\s]*[\"\']?\d+;[\s]*URL[\s]*=[\s]*([^\"\']*?)[\"\']?>'i",$results,$match))
  		{
--- 1057,1063 ----
  			$this->headers[] = $result_headers[$currentHeader];
  		}
  
! 		// check if there is a redirect meta tag
  
  		if(preg_match("'<meta[\s]*http-equiv[^>]*?content[\s]*=[\s]*[\"\']?\d+;[\s]*URL[\s]*=[\s]*([^\"\']*?)[\"\']?>'i",$results,$match))
  		{
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-customize-control.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-customize-control.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-customize-control.php	2012-11-21 16:31:55.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-customize-control.php	2013-05-22 16:01:57.000000000 -0500
***************
*** 384,390 ****
  		<label>
  			<span class="customize-control-title"><?php echo esc_html( $this->label ); ?></span>
  			<div class="customize-control-content">
! 				<input class="color-picker-hex" type="text" maxlength="7" placeholder="<?php esc_attr_e( 'Hex Value' ); ?>"<?php echo $default_attr ?> />
  			</div>
  		</label>
  		<?php
--- 384,390 ----
  		<label>
  			<span class="customize-control-title"><?php echo esc_html( $this->label ); ?></span>
  			<div class="customize-control-content">
! 				<input class="color-picker-hex" type="text" maxlength="7" placeholder="<?php esc_attr_e( 'Hex Value' ); ?>"<?php echo $default_attr; ?> />
  			</div>
  		</label>
  		<?php
***************
*** 593,601 ****
  	 */
  	public function tab_upload_new() {
  		if ( ! _device_can_upload() ) {
! 			?>
! 			<p><?php _e('The web browser on your device cannot be used to upload files. You may be able to use the <a href="http://wordpress.org/extend/mobile/">native app for your device</a> instead.'); ?></p>
! 			<?php
  		} else {
  			?>
  			<div class="upload-dropzone">
--- 593,599 ----
  	 */
  	public function tab_upload_new() {
  		if ( ! _device_can_upload() ) {
! 			echo '<p>' . sprintf( __('The web browser on your device cannot be used to upload files. You may be able to use the <a href="%s">native app for your device</a> instead.'), 'http://wordpress.org/mobile/' ) . '</p>';
  		} else {
  			?>
  			<div class="upload-dropzone">
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-customize-manager.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-customize-manager.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-customize-manager.php	2012-11-21 16:31:55.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-customize-manager.php	2013-07-12 15:41:46.000000000 -0500
***************
*** 310,316 ****
  	public function post_value( $setting ) {
  		if ( ! isset( $this->_post_values ) ) {
  			if ( isset( $_POST['customized'] ) )
! 				$this->_post_values = json_decode( stripslashes( $_POST['customized'] ), true );
  			else
  				$this->_post_values = false;
  		}
--- 310,316 ----
  	public function post_value( $setting ) {
  		if ( ! isset( $this->_post_values ) ) {
  			if ( isset( $_POST['customized'] ) )
! 				$this->_post_values = json_decode( wp_unslash( $_POST['customized'] ), true );
  			else
  				$this->_post_values = false;
  		}
***************
*** 512,517 ****
--- 512,519 ----
  			$setting->save();
  		}
  
+ 		do_action( 'customize_save_after', $this );
+ 
  		die;
  	}
  
***************
*** 897,905 ****
  		if ( $menus ) {
  			$choices = array( 0 => __( '&mdash; Select &mdash;' ) );
  			foreach ( $menus as $menu ) {
! 				$truncated_name = wp_html_excerpt( $menu->name, 40 );
! 				$truncated_name = ( $truncated_name == $menu->name ) ? $menu->name : trim( $truncated_name ) . '&hellip;';
! 				$choices[ $menu->term_id ] = $truncated_name;
  			}
  
  			foreach ( $locations as $location => $description ) {
--- 899,905 ----
  		if ( $menus ) {
  			$choices = array( 0 => __( '&mdash; Select &mdash;' ) );
  			foreach ( $menus as $menu ) {
! 				$choices[ $menu->term_id ] = wp_html_excerpt( $menu->name, 40, '&hellip;' );
  			}
  
  			foreach ( $locations as $location => $description ) {
***************
*** 975,980 ****
--- 975,981 ----
  	 * Callback for validating the header_textcolor value.
  	 *
  	 * Accepts 'blank', and otherwise uses sanitize_hex_color_no_hash().
+ 	 * Returns default text color if hex color is empty.
  	 *
  	 * @since 3.4.0
  	 *
***************
*** 982,988 ****
  	 * @return string
  	 */
  	public function _sanitize_header_textcolor( $color ) {
! 		return ( 'blank' === $color ) ? 'blank' : sanitize_hex_color_no_hash( $color );
  	}
  };
  
--- 983,996 ----
  	 * @return string
  	 */
  	public function _sanitize_header_textcolor( $color ) {
! 		if ( 'blank' === $color )
! 			return 'blank';
! 
! 		$color = sanitize_hex_color_no_hash( $color );
! 		if ( empty( $color ) )
! 			$color = get_theme_support( 'custom-header', 'default-text-color' );
! 
! 		return $color;
  	}
  };
  
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-customize-section.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-customize-section.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-customize-section.php	2012-11-21 16:31:55.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-customize-section.php	2013-02-14 16:58:04.000000000 -0600
***************
*** 79,87 ****
  	 */
  	protected function render() {
  		?>
! 		<li id="customize-section-<?php echo esc_attr( $this->id ); ?>" class="control-section customize-section">
! 			<h3 class="customize-section-title" tabindex="0" title="<?php echo esc_attr( $this->description ); ?>"><?php echo esc_html( $this->title ); ?></h3>
! 			<ul class="customize-section-content">
  				<?php
  				foreach ( $this->controls as $control )
  					$control->maybe_render();
--- 79,87 ----
  	 */
  	protected function render() {
  		?>
! 		<li id="accordion-section-<?php echo esc_attr( $this->id ); ?>" class="control-section accordion-section">
! 			<h3 class="accordion-section-title" tabindex="0" title="<?php echo esc_attr( $this->description ); ?>"><?php echo esc_html( $this->title ); ?></h3>
! 			<ul class="accordion-section-content">
  				<?php
  				foreach ( $this->controls as $control )
  					$control->maybe_render();
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-customize-setting.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-customize-setting.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-customize-setting.php	2012-11-21 16:31:55.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-customize-setting.php	2013-03-03 10:30:38.000000000 -0600
***************
*** 144,150 ****
  	 * @return mixed Null if an input isn't valid, otherwise the sanitized value.
  	 */
  	public function sanitize( $value ) {
! 		$value = stripslashes_deep( $value );
  		return apply_filters( "customize_sanitize_{$this->id}", $value, $this );
  	}
  
--- 144,150 ----
  	 * @return mixed Null if an input isn't valid, otherwise the sanitized value.
  	 */
  	public function sanitize( $value ) {
! 		$value = wp_unslash( $value );
  		return apply_filters( "customize_sanitize_{$this->id}", $value, $this );
  	}
  
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-editor.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-editor.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-editor.php	2012-12-07 12:50:16.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-editor.php	2013-07-18 17:44:40.000000000 -0500
***************
*** 152,158 ****
  	}
  
  	public static function editor_settings($editor_id, $set) {
- 		global $editor_styles;
  		$first_run = false;
  
  		if ( empty(self::$first_init) ) {
--- 152,157 ----
***************
*** 176,182 ****
  				$qtInit = array_merge($qtInit, $set['quicktags']);
  
  			if ( empty($qtInit['buttons']) )
! 				$qtInit['buttons'] = 'strong,em,link,block,del,ins,img,ul,ol,li,code,more,spell,close';
  
  			if ( $set['dfw'] )
  				$qtInit['buttons'] .= ',fullscreen';
--- 175,181 ----
  				$qtInit = array_merge($qtInit, $set['quicktags']);
  
  			if ( empty($qtInit['buttons']) )
! 				$qtInit['buttons'] = 'strong,em,link,block,del,ins,img,ul,ol,li,code,more,close';
  
  			if ( $set['dfw'] )
  				$qtInit['buttons'] .= ',fullscreen';
***************
*** 193,199 ****
  				self::$baseurl = includes_url('js/tinymce');
  				self::$mce_locale = $mce_locale = ( '' == get_locale() ) ? 'en' : strtolower( substr(get_locale(), 0, 2) ); // only ISO 639-1
  				$no_captions = (bool) apply_filters( 'disable_captions', '' );
! 				$plugins = array( 'inlinepopups', 'spellchecker', 'tabfocus', 'paste', 'media', 'fullscreen', 'wordpress', 'wpeditimage', 'wpgallery', 'wplink', 'wpdialogs' );
  				$first_run = true;
  				$ext_plugins = '';
  
--- 192,198 ----
  				self::$baseurl = includes_url('js/tinymce');
  				self::$mce_locale = $mce_locale = ( '' == get_locale() ) ? 'en' : strtolower( substr(get_locale(), 0, 2) ); // only ISO 639-1
  				$no_captions = (bool) apply_filters( 'disable_captions', '' );
! 				$plugins = array( 'inlinepopups', 'tabfocus', 'paste', 'media', 'fullscreen', 'wordpress', 'wpeditimage', 'wpgallery', 'wplink', 'wpdialogs' );
  				$first_run = true;
  				$ext_plugins = '';
  
***************
*** 286,305 ****
  				self::$plugins = $plugins;
  				self::$ext_plugins = $ext_plugins;
  
! 				/*
! 				translators: These languages show up in the spellchecker drop-down menu, in the order specified, and with the first
! 				language listed being the default language. They must be comma-separated and take the format of name=code, where name
! 				is the language name (which you may internationalize), and code is a valid ISO 639 language code. Please test the
! 				spellchecker with your values.
! 				*/
! 				$mce_spellchecker_languages = __( 'English=en,Danish=da,Dutch=nl,Finnish=fi,French=fr,German=de,Italian=it,Polish=pl,Portuguese=pt,Spanish=es,Swedish=sv' );
! 
! 				/*
! 				The following filter allows localization scripts to change the languages displayed in the spellchecker's drop-down menu.
! 				By default it uses Google's spellchecker API, but can be configured to use PSpell/ASpell if installed on the server.
! 				The + sign marks the default language. More: http://www.tinymce.com/wiki.php/Plugin:spellchecker.
! 				*/
! 				$mce_spellchecker_languages = apply_filters( 'mce_spellchecker_languages', '+' . $mce_spellchecker_languages );
  
  				self::$first_init = array(
  					'mode' => 'exact',
--- 285,306 ----
  				self::$plugins = $plugins;
  				self::$ext_plugins = $ext_plugins;
  
! 				if ( in_array( 'spellchecker', $plugins ) ) {
! 					/*
! 					translators: These languages show up in the spellchecker drop-down menu, in the order specified, and with the first
! 					language listed being the default language. They must be comma-separated and take the format of name=code, where name
! 					is the language name (which you may internationalize), and code is a valid ISO 639 language code. Please test the
! 					spellchecker with your values.
! 					*/
! 					$mce_spellchecker_languages = __( 'English=en,Danish=da,Dutch=nl,Finnish=fi,French=fr,German=de,Italian=it,Polish=pl,Portuguese=pt,Spanish=es,Swedish=sv' );
! 
! 					/*
! 					The following filter allows localization scripts to change the languages displayed in the spellchecker's drop-down menu.
! 					By default it uses Google's spellchecker API, but can be configured to use PSpell/ASpell if installed on the server.
! 					The + sign marks the default language. More: http://www.tinymce.com/wiki.php/Plugin:spellchecker.
! 					*/
! 					$mce_spellchecker_languages = apply_filters( 'mce_spellchecker_languages', '+' . $mce_spellchecker_languages );
! 				}
  
  				self::$first_init = array(
  					'mode' => 'exact',
***************
*** 307,313 ****
  					'theme' => 'advanced',
  					'skin' => 'wp_theme',
  					'language' => self::$mce_locale,
- 					'spellchecker_languages' => $mce_spellchecker_languages,
  					'theme_advanced_toolbar_location' => 'top',
  					'theme_advanced_toolbar_align' => 'left',
  					'theme_advanced_statusbar_location' => 'bottom',
--- 308,313 ----
***************
*** 344,363 ****
  					'paste_strip_class_attributes' => 'all',
  					'paste_text_use_dialog' => true,
  					'webkit_fake_resize' => false,
! 					'spellchecker_rpc_url' => self::$baseurl . '/plugins/spellchecker/rpc.php',
  					'schema' => 'html5',
  					'wpeditimage_disable_captions' => $no_captions,
  					'wp_fullscreen_content_css' => self::$baseurl . '/plugins/wpfullscreen/css/wp-fullscreen.css',
  					'plugins' => implode( ',', $plugins )
  				);
  
  				// load editor_style.css if the current theme supports it
! 				if ( ! empty( $editor_styles ) && is_array( $editor_styles ) ) {
  					$mce_css = array();
! 					$editor_styles = array_unique($editor_styles);
  					$style_uri = get_stylesheet_directory_uri();
  					$style_dir = get_stylesheet_directory();
  
  					if ( is_child_theme() ) {
  						$template_uri = get_template_directory_uri();
  						$template_dir = get_template_directory();
--- 344,379 ----
  					'paste_strip_class_attributes' => 'all',
  					'paste_text_use_dialog' => true,
  					'webkit_fake_resize' => false,
! 					'preview_styles' => 'font-family font-weight text-decoration text-transform',
  					'schema' => 'html5',
  					'wpeditimage_disable_captions' => $no_captions,
  					'wp_fullscreen_content_css' => self::$baseurl . '/plugins/wpfullscreen/css/wp-fullscreen.css',
  					'plugins' => implode( ',', $plugins )
  				);
  
+ 				if ( in_array( 'spellchecker', $plugins ) ) {
+ 					self::$first_init['spellchecker_rpc_url'] = self::$baseurl . '/plugins/spellchecker/rpc.php';
+ 					self::$first_init['spellchecker_languages'] = $mce_spellchecker_languages;
+ 				}
+ 
  				// load editor_style.css if the current theme supports it
! 				if ( ! empty( $GLOBALS['editor_styles'] ) && is_array( $GLOBALS['editor_styles'] ) ) {
! 					$editor_styles = $GLOBALS['editor_styles'];
! 
  					$mce_css = array();
! 					$editor_styles = array_unique( array_filter( $editor_styles ) );
  					$style_uri = get_stylesheet_directory_uri();
  					$style_dir = get_stylesheet_directory();
  
+ 					// Support externally referenced styles (like, say, fonts).
+ 					foreach ( $editor_styles as $key => $file ) {
+ 						if ( preg_match( '~^(https?:)?//~', $file ) ) {
+ 							$mce_css[] = esc_url_raw( $file );
+ 							unset( $editor_styles[ $key ] );
+ 						}
+ 					}
+ 
+ 					// Look in a parent theme first, that way child theme CSS overrides.
  					if ( is_child_theme() ) {
  						$template_uri = get_template_directory_uri();
  						$template_dir = get_template_directory();
***************
*** 396,403 ****
  
  			$body_class = $editor_id;
  
! 			if ( $post = get_post() )
! 				$body_class .= ' post-type-' . $post->post_type;
  
  			if ( !empty($set['tinymce']['body_class']) ) {
  				$body_class .= ' ' . $set['tinymce']['body_class'];
--- 412,427 ----
  
  			$body_class = $editor_id;
  
! 			if ( $post = get_post() ) {
! 				$body_class .= ' post-type-' . sanitize_html_class( $post->post_type ) . ' post-status-' . sanitize_html_class( $post->post_status );
! 				if ( post_type_supports( $post->post_type, 'post-formats' ) ) {
! 					$post_format = get_post_format( $post );
! 					if ( $post_format && ! is_wp_error( $post_format ) )
! 						$body_class .= ' post-format-' . sanitize_html_class( $post_format );
! 					else
! 						$body_class .= ' post-format-standard';
! 				}
! 			}
  
  			if ( !empty($set['tinymce']['body_class']) ) {
  				$body_class .= ' ' . $set['tinymce']['body_class'];
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-error.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-error.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-error.php	2012-01-08 11:01:11.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-error.php	2013-06-24 13:23:45.000000000 -0500
***************
*** 194,206 ****
  /**
   * Check whether variable is a WordPress Error.
   *
!  * Looks at the object and if a WP_Error class. Does not check to see if the
!  * parent is also WP_Error, so can't inherit WP_Error and still use this
!  * function.
   *
   * @since 2.1.0
   *
!  * @param mixed $thing Check if unknown variable is WordPress Error object.
   * @return bool True, if WP_Error. False, if not WP_Error.
   */
  function is_wp_error($thing) {
--- 194,204 ----
  /**
   * Check whether variable is a WordPress Error.
   *
!  * Returns true if $thing is an object of the WP_Error class.
   *
   * @since 2.1.0
   *
!  * @param mixed $thing Check if unknown variable is a WP_Error object.
   * @return bool True, if WP_Error. False, if not WP_Error.
   */
  function is_wp_error($thing) {
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-image-editor-gd.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-image-editor-gd.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-image-editor-gd.php	2012-12-09 12:01:38.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-image-editor-gd.php	2013-07-17 16:16:44.000000000 -0500
***************
*** 97,102 ****
--- 97,107 ----
  		if ( ! $size )
  			return new WP_Error( 'invalid_image', __('Could not read image size.'), $this->file );
  
+ 		if ( function_exists( 'imagealphablending' ) && function_exists( 'imagesavealpha' ) ) {
+ 			imagealphablending( $this->image, false );
+ 			imagesavealpha( $this->image, true );
+ 		}
+ 
  		$this->update_size( $size[0], $size[1] );
  		$this->mime_type = $size['mime'];
  
***************
*** 173,182 ****
  	 * Processes current image and saves to disk
  	 * multiple sizes from single source.
  	 *
  	 * @since 3.5.0
  	 * @access public
  	 *
! 	 * @param array $sizes { {'width'=>int, 'height'=>int, 'crop'=>bool}, ... }
  	 * @return array
  	 */
  	public function multi_resize( $sizes ) {
--- 178,190 ----
  	 * Processes current image and saves to disk
  	 * multiple sizes from single source.
  	 *
+ 	 * 'width' and 'height' are required.
+ 	 * 'crop' defaults to false when not provided.
+ 	 *
  	 * @since 3.5.0
  	 * @access public
  	 *
! 	 * @param array $sizes { {'width'=>int, 'height'=>int, ['crop'=>bool]}, ... }
  	 * @return array
  	 */
  	public function multi_resize( $sizes ) {
***************
*** 184,189 ****
--- 192,203 ----
  		$orig_size = $this->size;
  
  		foreach ( $sizes as $size => $size_data ) {
+ 			if ( ! ( isset( $size_data['width'] ) && isset( $size_data['height'] ) ) )
+ 				continue;
+ 
+ 			if ( ! isset( $size_data['crop'] ) )
+ 				$size_data['crop'] = false;
+ 
  			$image = $this->_resize( $size_data['width'], $size_data['height'], $size_data['crop'] );
  
  			if( ! is_wp_error( $image ) ) {
***************
*** 279,286 ****
  	 * @since 3.5.0
  	 * @access public
  	 *
! 	 * @param boolean $horz Horizontal Flip
! 	 * @param boolean $vert Vertical Flip
  	 * @returns boolean|WP_Error
  	 */
  	public function flip( $horz, $vert ) {
--- 293,300 ----
  	 * @since 3.5.0
  	 * @access public
  	 *
! 	 * @param boolean $horz Flip along Horizontal Axis
! 	 * @param boolean $vert Flip along Vertical Axis
  	 * @returns boolean|WP_Error
  	 */
  	public function flip( $horz, $vert ) {
***************
*** 387,390 ****
--- 401,422 ----
  				return imagejpeg( $this->image, null, $this->quality );
  		}
  	}
+ 
+ 	/**
+ 	 * Either calls editor's save function or handles file as a stream.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access protected
+ 	 *
+ 	 * @param string|stream $filename
+ 	 * @param callable $function
+ 	 * @param array $arguments
+ 	 * @return boolean
+ 	 */
+ 	protected function make_image( $filename, $function, $arguments ) {
+ 		if ( wp_is_stream( $filename ) )
+ 			$arguments[1] = null;
+ 
+ 		return parent::make_image( $filename, $function, $arguments );
+ 	}
  }
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-image-editor-imagick.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-image-editor-imagick.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-image-editor-imagick.php	2012-12-09 12:01:38.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-image-editor-imagick.php	2013-07-22 12:13:41.000000000 -0500
***************
*** 19,25 ****
  	protected $image = null; // Imagick Object
  
  	function __destruct() {
! 		if ( $this->image ) {
  			// we don't need the original in memory anymore
  			$this->image->clear();
  			$this->image->destroy();
--- 19,25 ----
  	protected $image = null; // Imagick Object
  
  	function __destruct() {
! 		if ( $this->image instanceof Imagick ) {
  			// we don't need the original in memory anymore
  			$this->image->clear();
  			$this->image->destroy();
***************
*** 97,103 ****
  				return false;
  
  		try {
! 			return ( (bool) Imagick::queryFormats( $imagick_extension ) );
  		}
  		catch ( Exception $e ) {
  			return false;
--- 97,103 ----
  				return false;
  
  		try {
! 			return ( (bool) @Imagick::queryFormats( $imagick_extension ) );
  		}
  		catch ( Exception $e ) {
  			return false;
***************
*** 113,119 ****
  	 * @return boolean|WP_Error True if loaded; WP_Error on failure.
  	 */
  	public function load() {
! 		if ( $this->image )
  			return true;
  
  		if ( ! is_file( $this->file ) && ! preg_match( '|^https?://|', $this->file ) )
--- 113,119 ----
  	 * @return boolean|WP_Error True if loaded; WP_Error on failure.
  	 */
  	public function load() {
! 		if ( $this->image instanceof Imagick )
  			return true;
  
  		if ( ! is_file( $this->file ) && ! preg_match( '|^https?://|', $this->file ) )
***************
*** 245,254 ****
  	 * Processes current image and saves to disk
  	 * multiple sizes from single source.
  	 *
  	 * @since 3.5.0
  	 * @access public
  	 *
! 	 * @param array $sizes { {'width'=>int, 'height'=>int, 'crop'=>bool}, ... }
  	 * @return array
  	 */
  	public function multi_resize( $sizes ) {
--- 245,257 ----
  	 * Processes current image and saves to disk
  	 * multiple sizes from single source.
  	 *
+ 	 * 'width' and 'height' are required.
+ 	 * 'crop' defaults to false when not provided.
+ 	 *
  	 * @since 3.5.0
  	 * @access public
  	 *
! 	 * @param array $sizes { {'width'=>int, 'height'=>int, ['crop'=>bool]}, ... }
  	 * @return array
  	 */
  	public function multi_resize( $sizes ) {
***************
*** 260,265 ****
--- 263,274 ----
  			if ( ! $this->image )
  				$this->image = $orig_image->getImage();
  
+ 			if ( ! ( isset( $size_data['width'] ) && isset( $size_data['height'] ) ) )
+ 				continue;
+ 
+ 			if ( ! isset( $size_data['crop'] ) )
+ 				$size_data['crop'] = false;
+ 
  			$resize_result = $this->resize( $size_data['width'], $size_data['height'], $size_data['crop'] );
  
  			if( ! is_wp_error( $resize_result ) ) {
***************
*** 356,363 ****
  	 * @since 3.5.0
  	 * @access public
  	 *
! 	 * @param boolean $horz Horizontal Flip
! 	 * @param boolean $vert Vertical Flip
  	 * @returns boolean|WP_Error
  	 */
  	public function flip( $horz, $vert ) {
--- 365,372 ----
  	 * @since 3.5.0
  	 * @access public
  	 *
! 	 * @param boolean $horz Flip along Horizontal Axis
! 	 * @param boolean $vert Flip along Vertical Axis
  	 * @returns boolean|WP_Error
  	 */
  	public function flip( $horz, $vert ) {
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-image-editor.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-image-editor.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-wp-image-editor.php	2012-12-06 01:56:04.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-wp-image-editor.php	2013-07-17 16:16:44.000000000 -0500
***************
*** 97,107 ****
  	 * Processes current image and saves to disk
  	 * multiple sizes from single source.
  	 *
  	 * @since 3.5.0
  	 * @access public
  	 * @abstract
  	 *
! 	 * @param array $sizes { {'width'=>int, 'height'=>int, 'crop'=>bool}, ... }
  	 * @return array
  	 */
  	abstract public function multi_resize( $sizes );
--- 97,110 ----
  	 * Processes current image and saves to disk
  	 * multiple sizes from single source.
  	 *
+ 	 * 'width' and 'height' are required.
+ 	 * 'crop' defaults to false when not provided.
+ 	 *
  	 * @since 3.5.0
  	 * @access public
  	 * @abstract
  	 *
! 	 * @param array $sizes { {'width'=>int, 'height'=>int, ['crop'=>bool]}, ... }
  	 * @return array
  	 */
  	abstract public function multi_resize( $sizes );
***************
*** 144,151 ****
  	 * @access public
  	 * @abstract
  	 *
! 	 * @param boolean $horz Horizontal Flip
! 	 * @param boolean $vert Vertical Flip
  	 * @return boolean|WP_Error
  	 */
  	abstract public function flip( $horz, $vert );
--- 147,154 ----
  	 * @access public
  	 * @abstract
  	 *
! 	 * @param boolean $horz Flip along Horizontal Axis
! 	 * @param boolean $vert Flip along Vertical Axis
  	 * @return boolean|WP_Error
  	 */
  	abstract public function flip( $horz, $vert );
***************
*** 324,334 ****
  	 * @return boolean
  	 */
  	protected function make_image( $filename, $function, $arguments ) {
- 		$dst_file = $filename;
- 
  		if ( $stream = wp_is_stream( $filename ) ) {
- 			$filename = null;
  			ob_start();
  		}
  
  		$result = call_user_func_array( $function, $arguments );
--- 327,337 ----
  	 * @return boolean
  	 */
  	protected function make_image( $filename, $function, $arguments ) {
  		if ( $stream = wp_is_stream( $filename ) ) {
  			ob_start();
+ 		} else {
+ 			// The directory containing the original file may no longer exist when using a replication plugin. 
+ 			wp_mkdir_p( dirname( $filename ) ); 
  		}
  
  		$result = call_user_func_array( $function, $arguments );
***************
*** 336,342 ****
  		if ( $result && $stream ) {
  			$contents = ob_get_contents();
  
! 			$fp = fopen( $dst_file, 'w' );
  
  			if ( ! $fp )
  				return false;
--- 339,345 ----
  		if ( $result && $stream ) {
  			$contents = ob_get_contents();
  
! 			$fp = fopen( $filename, 'w' );
  
  			if ( ! $fp )
  				return false;
